using System;
using System.Runtime.Serialization;

namespace DataBroker.Dal
{
    /// <summary>
    /// Summary description for D2BkException.
    /// </summary>
    public class D2BkException : Exception
    {
        /// <summary>
        /// Exception thrown when dealing with the D2Bk layer
        /// </summary>
        public D2BkException() : base("Exception in Entity")
        {
        }
        /// <summary>
        /// Exception thrown when dealing with the D2Bk layer
        /// </summary>
        /// <param name="message">Message for exception.</param>
        public D2BkException(string message) : base(message)
        {
			
        }
        /// <summary>
        /// Exception thrown when dealing with the D2Bk layer
        /// </summary>
        /// <param name="message">Message for exception.</param>
        /// <param name="inner">Inner Exception</param>
        public D2BkException(string message, Exception inner) : base(message, inner)
        {
			
        }

        /// <summary>
        /// Exception thrown when dealing with the D2Bk layer
        /// </summary>
        /// <param name="info">Message for exception.</param>
        /// <param name="context">Inner Exception</param>
        protected D2BkException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
				
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public class InvalidUserException : D2BkException
    {
        /// <summary>
        /// 
        /// </summary>
        public InvalidUserException() : base("Invalid user or password")
        {
            
        }
    }
}