using System;
using System.Runtime.Serialization;

namespace DataBroker.Dao
{
    /// <summary>
    /// Summary description for EntityException.
    /// </summary>
    [Serializable]
    public class EntityException: Exception
    {
        /// <summary>
        /// Exception thrown when dealing with Entities
        /// </summary>
        public EntityException() : base("Exception in Entity")
        {
        }
        /// <summary>
        /// Exception thrown when dealing with Entities
        /// </summary>
        /// <param name="message">Message for exception.</param>
        public EntityException(string message) : base(message)
        {
			
        }
        /// <summary>
        /// Exception thrown when dealing with Entities
        /// </summary>
        /// <param name="message">Message for exception.</param>
        /// <param name="inner">Inner Exception</param>
        public EntityException(string message, Exception inner) : base(message, inner)
        {
			
        }
        /// <summary>
        /// Exception thrown when dealing with Entities
        /// </summary>
        /// <param name="info">Message for exception.</param>
        /// <param name="context">Inner Exception</param>
        protected EntityException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
			
        }
    }
}